Bug 509332 - gtk_enumerate_printers doesn't provide default printer if there are only remote printers
gtk_enumerate_printers doesn't provide default printer if there are only remo...
Status: CLOSED WONTFIX
Product: Fedora
Classification: Fedora
Component: gtk2 (Show other bugs)
11
All Linux
low Severity medium
: ---
: ---
Assigned To: Marek Kašík
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2009-07-02 05:26 EDT by Zoltan Boszormenyi
Modified: 2010-06-28 09:26 EDT (History)
1 user (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2010-06-28 09:26:01 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Zoltan Boszormenyi 2009-07-02 05:26:56 EDT
Description of problem:

In a GTK2 application (which is actually the external helper part of
a browser plugin) gtk_enumerate_printers() calls the provided GtkPrinterFunc:

static gboolean
oppdf_get_default_printer(GtkPrinter *printer, gpointer data)
{
        gboolean ret = gtk_printer_is_default(printer);

        printf("oppdf-handler: printer name '%s' %s\n",
                gtk_printer_get_name(printer), ret ? "DEFAULT" : "");
        if (ret)
                oppdf_default_printer = printer;

        return ret;
}

...

   gtk_enumerate_printers(oppdf_get_default_printer, NULL, NULL, FALSE);

...

The list I get is:

oppdf-handler: printer name 'Nyomtatás fájlba' 
oppdf-handler: printer name 'Cups-PDF' 
oppdf-handler: printer name 'HP_LaserJet_1020' 
oppdf-handler: printer name 'MFC-215C' 

The "Nyomtatás fájlba" is the "Print to file" option.

The plugin/application was developed and tested on Fedora 11 inside
a VMWare guest. My host is Fedora 9, has the last three printers defined,
the default is set to the HP_LaserJet_1020.

As you can see in the above list, there is no default printer.
On the other hand, when I actually put the print dialog on the screen,
the 'HP_LaserJet_1020' is selected by default. So the dialog knows
something that gtk_printer_is_default() doesn't tell.

Version-Release number of selected component (if applicable):

$ rpm -q gtk2
gtk2-2.16.2-1.fc11.x86_64
gtk2-2.16.2-1.fc11.i586

How reproducible:

Always.

Steps to Reproduce:
1. Have two machines
2. Install printers on only one of them, set a default printer.
3. Run some GTK code utilizing gtk_enumerate_printers() on the other.
  
Actual results:

Putting up the GTK2 print dialog on the screen, it selects the remote
default printer. Using gtk_printer_is_default() on the GtkPrinter *printer
provided by gtk_enumerate_printers() doesn't detect default printer.

Expected results:

The behaviour the the two should match.

Additional info:

I found Bug 478400 that's similar (applicable to Fedora 10) but closed.
The patch attached to this bug seems to be in gtk2-2.16.2-1.fc11.src.rpm.
Comment 1 Bug Zapper 2010-04-27 11:25:33 EDT
This message is a reminder that Fedora 11 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 11.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '11'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 11's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 11 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 2 Bug Zapper 2010-06-28 09:26:01 EDT
Fedora 11 changed to end-of-life (EOL) status on 2010-06-25. Fedora 11 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.